/* This sample project uses Edgar Allen Poe's The Fall of the House of Usher as a set of text to read 
and display.  Each mention of "I", the person telling the story, adds a drop of blood and thickens the red bar.
Each mention of "Usher" darkens the screen, and at the end of each line of text a skull appears.
very spooky halloweeny! Location of the mouse in the Y direction determines
how quickly the story is read*/


//declare all our variables and strings
String[] lines;
String[] words;
int k = 20;
int j = 0;
int i = 0;
int makeline = 0;
int drop_y = 50;
float drop_x = 0;
float backdrop = 240;
PFont font;
boolean makedropgo = false;
PImage img;

//in the setup we need to load the text, the image and the font
void setup() {
  lines = loadStrings("usher10.txt");
  img = loadImage("skulls2.jpg");
  font = loadFont("Arial-Black-48.vlw");
  textFont(font, 48);
  size(400, 800);
  smooth();
  background(240);
}


void draw(){
  frameRate(mouseY/20);    //by placing the framerate in the draw function we can have it change
  fill(backdrop, 100);
  rect(0, 0, width, height);    //our semi transparent backdrop for fading things
  makedrop();      //call the function to make a new drop of blood
  if(j < lines.length){    //this first if statement goes thru all the lines of text 
    String separators = WHITESPACE + "/<>*_;:?()\"-";    //these are the items we want to seperate words by and disclude from our final words
    words = splitTokens(lines[j], separators);    //using the seperators above, divide each line into words
    if ( i < words.length) {      //this if statement lets us go thru each word from the current line
      fill(255, 0, 0);
      rect(0, 50, width, makeline);    //draw our red rectangle which grows with each drop
      if(words[i].equals("I")) {    //if we find the word "I" then make a drop and make the red rect thicker
        fill(255, 0, 0);
        makeline += 5;
        drop_x = random(width);     //make the new drop fall from a random x value
        makedropgo = true;
      } 
      else if(words[i].startsWith("Usher")){   //if we see "Usher" then make that word black and darken the backdrop
        fill(0);
        backdrop -= 10;
      } 
      else {          //otherwise make text white
        fill(255);
      }  
      text(words[i], 0, 50);  //write the current word
      i++;    //go to the next word
    } 
    else {   //if we have hit the last word in the line, reset i, go to the next line, and show the scary skull!
      i = 0;
      j++;
      image(img, 0, 50, width, height);
    }
  } 
}

void makedrop() {

  if (makedropgo == true) {   //when the drop has been switched on, draw a red drop and move it to the proper x and y coordinates
    fill(255, 0, 0);
    pushMatrix();
    translate(drop_x, drop_y);
    beginShape();
    vertex(0, 0);
    bezierVertex(-20, 40, 20, 40, 0, 0);
    endShape();
    popMatrix();
    //ellipse(drop_x, drop_y, 25, 40);
    drop_y += 40;     //move the drop down by 40 units
  }
  if (drop_y > height) {   //once the drop reaches the bottom of the screen, reset the y value and turn the switch off
    makedropgo = false;
    drop_y = 50 + makeline;  //I added the + makeline so the drop would continue to fall from around the bottom of the red rect
  }

}
